#ifndef AIGroundNetworkWriter_h
#define AIGroundNetworkWriter_h

#include <Airport/Airport.h>

#include <iostream>
#include <map>
#include <string>

class AINetworkVertex;

typedef std::map<AINetworkVertex*,unsigned int> AIVertexIndexMap;

class AIGroundNetworkWriter {
public:
        AIGroundNetworkWriter(Airport::SmartRef airport);
        virtual ~AIGroundNetworkWriter();
        
        void write(std::ostream& outfile);
protected:
        void writeFrequencies(std::ostream& outfile);
        void writeGates(std::ostream& outfile);
        void writeNodes(std::ostream& outfile);
        void writeArcs(std::ostream& outfile);
        
        std::string latString(double lat);
        std::string lonString(double lon);
        
        Airport::SmartRef _airport;
        AIVertexIndexMap _vertexIndexMap;
        unsigned int _nextIndex;
};

#endif

