#ifndef AINetworkNodePlacementMode_h
#define AINetworkNodePlacementMode_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Map/Mode.h>

#include "AINetworkVertex.h"

#include <Airport/Airport.h>

class AINetworkNodePlacementMode : public Mode {
        
        DECLARE_CLASS(AINetworkNodePlacementMode)
        
public:
        AINetworkNodePlacementMode(Airport::SmartRef airport,
                                   bool connect,
                                   bool bidirectional=true);
        virtual ~AINetworkNodePlacementMode();
        
        /* Get a string for the status bar. */
	virtual wxString GetStatus();
        
        void OnLeftDown(wxMouseEvent& evt);
private:
        DECLARE_EVENT_TABLE()
        
        Airport::SmartRef _airport;
        bool _connect;
        bool _bidirectional;
};

#endif


