#ifndef AINetworkNodeSelection_h
#define AINetworkNodeSelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include "AINetworkVertexSelection.h"
#include "AINetworkNode.h"


class AINetworkNodeSelection: public AINetworkVertexSelection {
        
        DECLARE_CLASS(AINetworkNodeSelection)
        
public:
	AINetworkNodeSelection(MapSelectionManager* manager, AINetworkNode* content);

        virtual ~AINetworkNodeSelection();
        
        virtual bool Hit(Point3D p);
        
        virtual MapSelectionHandle* HitHandle(Point3D p);
        
        virtual wxRect GetDeviceBounds() const;
        
        virtual void Paint(wxDC& dc);
        
        virtual wxString EndDrag() {
                return wxT("Moving AI network node");
        }
        
        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);

        AINetworkNode* GetContent() const { return wxDynamicCast(AINetworkVertexSelection::GetContent(),AINetworkNode); }
};

#endif


