#ifndef StartupLocationSelection_h
#define StartupLocationSelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include "AINetworkVertexSelection.h"

#include "StartupLocationMapObject.h"


class StartupLocationSelection: public AINetworkVertexSelection {
        
        DECLARE_CLASS(StartupLocationSelection)
        
public:
	StartupLocationSelection(MapSelectionManager* manager, StartupLocationMapObject* content);

        virtual ~StartupLocationSelection();

        virtual MapSelectionHandle* HitHandle(Point3D p);
        
        virtual wxRect GetDeviceBounds() const;
        
        virtual wxString EndDrag() {
                return wxT("Moving Startup Location");
        }

        virtual void Paint(wxDC& dc);
        
        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);

        StartupLocationMapObject* GetContent() const { return wxDynamicCast(MapSelection::GetContent(),StartupLocationMapObject); }
protected:
        void PaintHandles(wxDC& dc);
};

#endif


