#if HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "Airport.h"

#include <Map/MapObjectContainer.h>
#include <Transactions/TransactionObject.h>

#include <wx/arrimpl.cpp>
WX_DEFINE_OBJARRAY(FrequencyEntryArray);

IMPLEMENT_CLASS(Airport,wxObject);

Airport::Airport(TransactionManager* tmgr,
                const wxString& icaoId,
                const wxString& name,
                AirportType type,
                float elevation,
                bool hasControlTower,
                bool hasDefaultBuildings):
        TransactionObject(tmgr),
        _runwayLayer(new MapObjectContainer(GetTransactionManager(),wxT("Runways"))),
        _taxiwayLayer(new MapObjectContainer(GetTransactionManager(),wxT("Taxiways"))),
        _objectsLayer(new MapObjectContainer(GetTransactionManager(),wxT("Objects"))),
        _groundNetworkLayer(new MapObjectContainer(GetTransactionManager(),wxT("Ground Network")))
{
        _myState._icaoId=icaoId;
        _myState._name=name;
        _myState._type=type;
        _myState._elevation=elevation;
        _myState._hasControlTower=hasControlTower;
        _myState._hasDefaultBuildings=hasDefaultBuildings;
}

Airport::~Airport() {
}


