#ifndef FrequencyEntry_h
#define FrequencyEntry_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

class FrequencyEntry {
public:
        typedef enum {
                FrequencyType_AWOS,
                FrequencyType_UNICOM,
                FrequencyType_Clearance,
                FrequencyType_Ground,
                FrequencyType_Tower,
                FrequencyType_Approach,
                FrequencyType_Departure
        } FrequencyType;
        
	FrequencyEntry(FrequencyType type, wxString frequency, wxString name):
                type(type),
                frequency(frequency),
                name(name)
        {
        }
        
        FrequencyEntry(const FrequencyEntry& entry):
                type(entry.type),
                frequency(entry.frequency),
                name(entry.name)
        {
        }
        
        virtual ~FrequencyEntry() {
        }
        
        FrequencyType GetType() const { return type; }
        const wxString& GetFrequency() const { return frequency; }
        const wxString& GetName() const { return name; }
        
        void SetType(FrequencyType v) { type=v; }
        void SetFrequency(const wxString& v) { frequency=v; }
        void SetName(const wxString& v) { name=v; }
protected:
        FrequencyType type;
        wxString frequency;
        wxString name;
};

#endif

