#if HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "WindsockSelection.h"
#include "WindsockMapObject.h"
#include <Map/MapEditor.h>
#include <Map/MapSelectionManager.h>

IMPLEMENT_CLASS(WindsockSelection,PointObjectSelection);

WindsockSelection::WindsockSelection(MapSelectionManager* manager, WindsockMapObject* content):
        PointObjectSelection(manager,content) {
}

WindsockSelection::~WindsockSelection() {
}

void WindsockSelection::ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass) {
        PointObjectSelection::ProvidePropertiesForClass(propgrid,targetClass);
        if (!targetClass->IsKindOf(CLASSINFO(WindsockSelection)))
                return;
        
        propgrid->Append(wxBoolProperty(wxT("Is Lighted"), wxT("WindsockSelection_IsLighted")));
        propgrid->Append(wxStringProperty(wxT("Name"), wxT("WindsockSelection_Name")));
}

void WindsockSelection::UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass) {
        PointObjectSelection::UpdatePropertiesForClass(propgrid,targetClass);
        if (!targetClass->IsKindOf(CLASSINFO(WindsockSelection)))
                return;

        propgrid->SetPropertyValue(wxT("WindsockSelection_IsLighted"),GetContent()->IsLighted());
        propgrid->SetPropertyValue(wxT("WindsockSelection_Name"),GetContent()->GetName());
}

void WindsockSelection::MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection) {
        PointObjectSelection::MarkDifferingPropertiesForClass(propgrid,targetClass,firstSelection);
        if (!targetClass->IsKindOf(CLASSINFO(WindsockSelection)))
                return;
        WindsockMapObject* firstContent=wxDynamicCast(firstSelection,WindsockSelection)->GetContent();
        WindsockMapObject* myContent=GetContent();

        if (firstContent->IsLighted()!=myContent->IsLighted())
                propgrid->SetPropertyUnspecified(wxT("WindsockSelection_IsLighted"));
        if (firstContent->GetName().Cmp(myContent->GetName())!=0)
                propgrid->SetPropertyUnspecified(wxT("WindsockSelection_Name"));
}

void WindsockSelection::UpdateObjectFromProperty(wxPGProperty* property) {
        const wxString& name=property->GetName();
        wxVariant value=property->GetValueAsVariant();

        if (name.Cmp(wxT("WindsockSelection_IsLighted"))==0) {
                GetContent()->SetIsLighted(value.GetBool());
        } else if (name.Cmp(wxT("WindsockSelection_Name"))==0) {
                GetContent()->SetName(property->GetValueAsString());
        } else {
                PointObjectSelection::UpdateObjectFromProperty(property);
        }
}


