#ifndef MapSimpleBackgroundImageCornerHandle_h
#define MapSimpleBackgroundImageCornerHandle_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include <Map/MapSelectionHandle.h>

#include "MapSimpleBackgroundImageSelection.h"

class MapSimpleBackgroundImageCornerHandle: public MapSelectionHandle {
        
        DECLARE_CLASS(MapSimpleBackgroundImageCornerHandle)
        
public:
	MapSimpleBackgroundImageCornerHandle(MapSimpleBackgroundImageSelection* selection,
                                             unsigned int corner);
        virtual ~MapSimpleBackgroundImageCornerHandle();
        
        virtual void StartDrag(Point3D currentPosition);
        
        virtual void Drag(Point3D currentPosition);
        
        virtual wxString EndDrag();
        
        MapSimpleBackgroundImageSelection* GetSelection() const {
                return wxDynamicCast(MapSelectionHandle::GetSelection(),
                                     MapSimpleBackgroundImageSelection);
        }
protected:
        unsigned int _corner;
        Point3D _localCorners[4];
        Point3D _handleOrigin;
        double _originalScale;
        Point3D _horizontal,_diagonal,_vertical;
        double _diagonalLengthSquared;
        Point3D _dragOrigin;
};

#endif

