#ifndef USGSLoadMode_h
#define USGSLoadMode_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <wx/filename.h>

#include "MapUSGSImageLayer.h"
#include <Map/Mode.h>

class USGSLoadMode : public Mode {
        
        DECLARE_CLASS(USGSLoadMode)
        
public:
        USGSLoadMode(MapUSGSImageLayer::SmartRef targetLayer,
                     wxFileName imgPath);
        virtual ~USGSLoadMode();
        
	virtual wxString GetStatus();
        
        void OnLeftButtonDown(wxMouseEvent& evt);
        void OnMouseMotion(wxMouseEvent& evt);
        void OnLeftButtonUp(wxMouseEvent& evt);
        void OnPaint(wxPaintEvent& evt);
        
        wxRect GetCurrentDeviceRectangle();
private:
        DECLARE_EVENT_TABLE()

        wxPoint _startPoint,_endPoint;
        
        bool _boxStarted;
        
        MapUSGSImageLayer::SmartRef _targetLayer;
        wxFileName _imgPath;
};

#endif


